#include "util.hh"
#include <GL/gl.h>

#define GL_PIXEL_UNPACK_BUFFER_EXT        0x88EC
#define GL_STREAM_DRAW                    0x88E0
#define GL_WRITE_ONLY                     0x88B9
#define GL_PIXEL_UNPACK_BUFFER_BINDING_EXT 0x88EF


struct GLExt {
  public:
    GLExt();
    bool nv_tex_rect_supported;
    bool nv_register_combiners2_supported;
    bool nv_pixel_data_range_supported;
    bool ext_pixel_buffer_object_supported;
    bool arb_multitexture_supported;
    bool use_yuv, use_yuv_complex;

    void (APIENTRY *glPixelDataRange) (GLenum, GLsizei, GLvoid *);

    void (APIENTRY *glGenBuffers) (GLsizei, GLuint *);
    void (APIENTRY *glBindBuffer) (GLenum, GLuint);
    void (APIENTRY *glBufferData) (GLenum, GLsizei , const GLvoid *, GLenum);
    GLvoid* (APIENTRY *glMapBuffer) (GLenum, GLenum);
    GLboolean (APIENTRY *glUnmapBuffer) (GLenum);
    void (APIENTRY *glDeleteBuffers) (GLsizei, const GLuint *);

    void (APIENTRY *glMultiTexCoord2f) (GLenum, GLfloat, GLfloat);                                            
    void (APIENTRY *glActiveTexture) (GLenum);

    void (APIENTRY *glCombinerParameterfv) (GLenum, const GLfloat *);
    void (APIENTRY *glCombinerParameteri) (GLenum, GLint);
    void (APIENTRY *glCombinerInput) (GLenum, GLenum, GLenum, GLenum, GLenum, GLenum);
    void (APIENTRY *glCombinerOutput) (GLenum, GLenum, GLenum, GLenum, GLenum, GLenum,
	GLenum, GLboolean, GLboolean, GLboolean);
    void (APIENTRY *glFinalCombinerInput) (GLenum, GLenum, GLenum, GLenum);
    void (APIENTRY *glSecondaryColor3f) (GLfloat, GLfloat, GLfloat);
};

extern GLExt *glext;
