#ifndef __GLPIXMAP_H
#define __GLPIXMAP_H
#include <GL/gl.h>
#include "pixmap.hh"
//Usually a texture or a group of textures positioned to (0,0)-(1,1)
class GLPixmap {
    double ratio;
  protected:
    bool loaded;
    int colorspace;
    bool texture_is_buffer_object;
    int texture_target;
    GLuint buf;
  public:
    int rotate;
    bool is_loaded();
    void set_ratio(double r);
    double get_ratio();
    virtual void display()=0;
    virtual ~GLPixmap();
};
class GLSimplePixmap : public GLPixmap {
    GLuint texture[3];
    double maxx[3], maxy[3];
    bool flip;
    void raw_display();
  public:
    GLSimplePixmap(Pixmap *p);
    ~GLSimplePixmap();
    virtual void display();
};
#endif /* __GLPIXMAP_H */
