#include "conf.hh"
#ifdef HAVE_IMLIB2
#include "pixmap.hh"
#include "glext.hh"
#include "util.hh"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GL/gl.h>
#define X_DISPLAY_MISSING
extern "C" {
#include <Imlib2.h>
}

class Imlib2Pixmap : public Pixmap {
  public:
    Imlib2Pixmap(const char *fn);
};

class Imlib2PixmapFactory : public PixmapFactory {
  public:
    Pixmap *create(const char *fn);
    bool accept_extension(const char *ext);
    const char *get_name();
};

const char *Imlib2PixmapFactory::get_name()
{
  return "Imlib2 Image";
}

bool Imlib2PixmapFactory::accept_extension(const char *ext)
{
  return true;
  //return !strcasecmp(ext, "jpg")||!strcasecmp(ext, "jpeg")||!strcasecmp(ext, "tiff")||
  //  !strcasecmp(ext, "tif")||!strcasecmp(ext, "gif");
}

Pixmap *Imlib2PixmapFactory::create(const char *fn)
{
  return new Imlib2Pixmap(fn);
}

Imlib2PixmapFactory imlib2_pixmap_factory;


Imlib2Pixmap::Imlib2Pixmap(const char *fn)
{
  Imlib_Image image=imlib_load_image(fn);
  if(image==NULL) {
    printf("%s is not a valid image\n", fn);
    data=NULL, w=-1, h=-1;
    return;
  }
  imlib_context_set_image(image);

  w=imlib_image_get_width();
  h=imlib_image_get_height();
  colorspace=GL_BGRA;
  compute_alloc_size();

  if(alloc_size>w*h*components)
    data=(unsigned char *)imlib_image_get_data();
  else {
    unsigned char *d2=(unsigned char *)imlib_image_get_data();
    data=(unsigned char *)malloc(alloc_size);
    memcpy(data, d2, w*h*components);
  }
  image_valid=true;
  flip=false;
}
#endif
