#include "pixmap.hh"
#include "util.hh"
#include "conf.hh"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GL/gl.h>
#include "glext.hh"

bool Pixmap::read_scanline(char *data)
{
  fprintf(stderr, "error: read_scanline not implemented for this class\n");
  return false;
}

Pixmap::~Pixmap()
{
  free(data);
}
Pixmap::Pixmap()
{
  use_data=true;
  image_valid=false;
  refcnt=1;
}
void Pixmap::ref()
{
  refcnt++;
}
void Pixmap::unref()
{
  refcnt--;
  if(!refcnt)
    delete this;
}

void Pixmap::compute_alloc_size()
{
  wpadded=w, hpadded=h;
  switch(colorspace) {
    case GL_LUMINANCE:
    case PIXMAP_COLORSPACE_BITMAP:
      components=1;
      break;
    case GL_RGBA:
    case GL_BGRA:
      components=4;
      break;
    default:
      components=3;
  }
  if(glext->nv_tex_rect_supported)
    alloc_size=w*h*components;
  else
    alloc_size=roundup(w)*roundup(h)*components;
}

void Pixmap::read_scanlines(unsigned char **data[3])
{
  fprintf(stderr, "error: read_scanlines not implemented for this class\n");
}

Pixmap *PixmapFactory::create(const char *fn)
{
  return NULL;
}
bool PixmapFactory::accept_extension(const char *ext)
{
  return false;
}

const char *PixmapFactory::get_name()
{
  return "undefined";
}

extern PixmapFactory   jpeg_pixmap_factory;
#ifdef HAVE_IMLIB2
extern PixmapFactory imlib2_pixmap_factory;
#endif
#ifdef HAVE_IMAGE_MAGICK
extern PixmapFactory im_pixmap_factory;
#endif

PixmapFactory *pixmap_factories[]={
  &jpeg_pixmap_factory,
#ifdef HAVE_IMLIB2
  &imlib2_pixmap_factory,
#endif
#ifdef HAVE_IMAGE_MAGICK
  &im_pixmap_factory,
#endif
  NULL
};

