#include <string.h>
#include <GL/gl.h>
#include "pixmap.hh"
int roundup(int x)
{
  int r=16;
  while(r<x)
    r<<=1;
  return r;
}
bool has_mimetype(char *fn, char *t)
{
  int l=strlen(fn), lt=strlen(t);
  return l>lt&&fn[l-lt-1]=='.'&&!strcasecmp(&fn[l-lt], t);
}
const char *get_extension(const char *fn)
{
  const char *e, *r=NULL;
  for(e=fn, r=NULL; *e; e++)
    if(*e=='.')
      r=e;
  if(!r)
    return e;
  return &r[1];
}
const char *get_color_space_string(int cspace)
{
  switch(cspace) {
    case GL_LUMINANCE:
      return "GL_LUMINANCE";
    case GL_RGB:
      return "GL_RGB";
    case GL_RGBA:
      return "GL_RGBA";
    case GL_BGRA:
      return "GL_BGRA";
    case PIXMAP_COLORSPACE_YUV:
      return "PIXMAP_COLORSPACE_YUV";
    case GL_BITMAP:
      return "GL_BITMAP";
    case PIXMAP_COLORSPACE_YUV_COMPLEX:
      return "PIXMAP_COLORSPACE_YUV_COMPLEX";
    default:
      return "unknown";
  }
}
